#ifndef _nuvread_h
#define _nuvread_h

#include "format.h"

typedef struct {
    int             num;
    int             denom;
} fraction;

typedef struct {
    int             fd;
    int             width;
    int             height;
    fraction        fps;
    int             gop_length;
    unsigned int    video_4cc;
    unsigned int    audio_4cc;
    int             audio_sample_rate_file;
    int             audio_sample_rate;
    int             audio_bits_per_sample;
    int             audio_channels;
    int             audio_compression_ratio;
    int             audio_quality;
    int             audio_bitrate_calc;
    int             audio_bitrate_closest;
    int             video_bitrate;
    long long int   seektable_offset;
    long long int   kfa_offset;
    long long int   frameCount;
    int             lastVideo;
    int             lastAudio;
    int             verbose;
} nuvFile;

typedef struct {
    rtframeheader   header;
    int             offset;
    int             length;
    char           *data;
} nuvFrame;

void nuv_free_frame( nuvFrame *frame );
nuvFile *nuv_init( char *filename, int verbose );
nuvFrame *nuv_read_frame( nuvFile *nv, char *searchList );
void nuv_dump_frame( nuvFile *nv, nuvFrame *frame );
void nuv_hex_dump( nuvFrame *frame );
void nuv_free_file( nuvFile *nv );
nuvFrame *nuv_duplicate_frame( nuvFrame *frame );

#endif


/*
 * vim:ts=4:sw=4:ai:et:si:sts=4
 */
