
/*HEADER---------------------------------------------------
* $Id: environment.h,v 1.1 2004/09/13 05:29:19 gjhurlbu Exp $
*
* Copyright 2004 Gavin Hurlbut
* All rights reserved
*
* Comments :
*
* Revision History:
* $Log: environment.h,v $
* Revision 1.1  2004/09/13 05:29:19  gjhurlbu
* - converted to threaded
*
*
*
*----------------------------------------------------------
*/
#ifndef environment_h_
#define environment_h_

#ifdef __GNUC__
/* We are compiling with GCC */

#define _UNUSED_ __attribute__ ((unused))
#define _PACKED_ __attribute__ ((packed))
#ifndef __cplusplus
#define _GNU_SOURCE
#endif
#ifndef _REENTRANT
#define _REENTRANT
#endif
#define _THREAD_SAFE

#else

/* Other compilers */
#define _UNUSED_
#define _PACKED_
#endif

/* CVS generated ID string (optional for h files) */
static char environment_h_ident[] _UNUSED_ = 
    "$Id: environment.h,v 1.1 2004/09/13 05:29:19 gjhurlbu Exp $";

#undef _FILE_OFFSET_BITS
#define _FILE_OFFSET_BITS 64

#define _LARGEFILE_SOURCE

#define O_LARGEFILE 0


/* NOTE: to use 'long long' in GCC, you need -Wno-long-long if using -pedantic
 * -Wall -Werror (which you should be)
 */
#ifndef __cplusplus
typedef int                    bool;
#endif
typedef char                   int8;
typedef short int              int16;
typedef int                    int32;
typedef long long int          int64;
typedef unsigned char          uint8;
typedef unsigned short int     uint16;
typedef unsigned int           uint32;
typedef unsigned long long int uint64;


/* Values for bool type */
#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif


#define BOOL(x)  ((x) ? TRUE : FALSE)

#define NELEMENTS(x)                (sizeof((x)) / sizeof((x)[0]))
#define OFFSETOF(elem,StructType)   ((char *)&(((StructType *)NULL)->elem) - \
                                       (char *)((StructType *)NULL))
#define ELEMSIZE(elem,StructType)   (sizeof(((StructType *)NULL)->elem))
#define FORCE_UINT32(x)             (*(uint32 *)&(x))

#endif
