
/*HEADER---------------------------------------------------
* $Id: logging.h,v 1.1 2004/09/13 05:29:19 gjhurlbu Exp $
*
* Copyright 2004 Gavin Hurlbut
* All rights reserved
*
* Comments :
*
* Revision History:
* $Log: logging.h,v $
* Revision 1.1  2004/09/13 05:29:19  gjhurlbu
* - converted to threaded
*
*
*--------------------------------------------------------*/
#ifndef logging_h_
#define logging_h_

/* CVS generated ID string (optional for h files) */
static char logging_h_ident[] _UNUSED_ = 
    "$Id: logging.h,v 1.1 2004/09/13 05:29:19 gjhurlbu Exp $";

/* Define the log levels (lower number is higher priority) */

typedef enum
{
    LOG_EMERG = 0,
    LOG_ALERT,
    LOG_CRIT,
    LOG_ERR,
    LOG_WARNING,
    LOG_NOTICE,
    LOG_INFO,
    LOG_DEBUG,
    LOG_UNKNOWN
} LogLevel_t;

#ifdef _LogLevelNames_
char *LogLevelNames[] =
{
    "LOG_EMERG",
    "LOG_ALERT",
    "LOG_CRIT",
    "LOG_ERR",
    "LOG_WARNING",
    "LOG_NOTICE",
    "LOG_INFO",
    "LOG_DEBUG",
    "LOG_UNKNOWN"
};
int LogLevelNameCount = NELEMENTS(LogLevelNames);
#else
extern char *LogLevelNames[];
extern int LogLevelNameCount;
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Define the external prototype */
void LogPrint( LogLevel_t level, char *format, ... );
bool LogFileAdd( char * filename );
bool LogStdoutAdd( void );
bool LogSyslogAdd( int facility );
bool LogFileRemove( char *filename );
bool LogTcpAdd( int fd );
bool LogTcpRemove( int fd );

#ifdef __cplusplus
}
#endif

#endif
