
/*HEADER---------------------------------------------------
* $Id: queue.h,v 1.1 2004/09/13 05:29:19 gjhurlbu Exp $
*
* Copyright 2004 Gavin Hurlbut
* All rights reserved
*
* Comments :
*
* Revision History:
* $Log: queue.h,v $
* Revision 1.1  2004/09/13 05:29:19  gjhurlbu
* - converted to threaded
*
*
*
*--------------------------------------------------------*/
#ifndef queue_h_
#define queue_h_

#include "environment.h"
#include <pthread.h>

/* CVS generated ID string (optional for h files) */
static char queue_h_ident[] _UNUSED_ = 
    "$Id: queue.h,v 1.1 2004/09/13 05:29:19 gjhurlbu Exp $";


typedef void * QueueItem_t;
typedef struct 
{ 
    uint32 numElements;
    uint32 numMask;
    uint32 head;
    uint32 tail;
    QueueItem_t *itemTable;
    pthread_mutex_t *mutex;
    bool full;
    pthread_cond_t *cNotFull;
    bool empty;
    pthread_cond_t *cNotEmpty;
} QueueObject_t;


#ifdef __cplusplus
extern "C" {
#endif

/* Function Prototypes */
QueueObject_t * QueueCreate( uint32 numElements );
bool QueueEnqueueItem( QueueObject_t *queue, QueueItem_t item ); 
QueueItem_t QueueDequeueItem( QueueObject_t *queue, int32 ms_timeout );
void QueueClear( QueueObject_t *queue, bool freeItems );
uint32 QueueUsed( QueueObject_t *queue );

#ifdef __cplusplus
}
#endif

#endif
