#undef _FILE_OFFSET_BITS
#define _FILE_OFFSET_BITS 64

#define _LARGEFILE_SOURCE

#define O_LARGEFILE 0

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>

#include "format.h"
#include "nuvread.h"


#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define BYTE(val,num) ((char)(((val) >> (8 * (num))) & 0xFF))

int nuvScan( char *filename );

int nuvScan( char *filename )
{
    nuvFile        *nv;
    nuvFrame       *frame;


    nv = nuv_init( filename, TRUE );
    if( !nv ) {
        fprintf( stderr, "Unable to open file" );
        return( 1 );
    }

    while( (frame = nuv_read_frame(nv, "AVSTRDXQK")) ) {
        nuv_dump_frame(nv, frame);
        nuv_free_frame(frame);
    }

    printf( "\nTotal NUV Frame Count: %lld\n\n", nv->frameCount );

    nuv_free_file(nv);

    return( 0 );
}

int main( int argc, char **argv )
{
    int     i;
    int     ret;

    if( argc == 1 ) {
        return( -1 );
    }

    for( i = 1; i < argc; i++ ) {
        ret = nuvScan( argv[i] );
        if( ret ) {
            return( ret );
        }
    }

    return( 0 );
}


/*
 * vim:ts=4:sw=4:ai:et:si:sts=4
 */
